class Pirrest.PhisicsEngine.Particle
{
   var curr;
   var prev;
   var temp;
   var mass;
   var dmc;
   function Particle($posX, $posY, $mass)
   {
      this.init($posX,$posY,$mass);
   }
   function init($posX, $posY, $mass)
   {
      this.curr = new Pirrest.PhisicsEngine.Vector($posX,$posY);
      this.prev = new Pirrest.PhisicsEngine.Vector($posX,$posY);
      this.temp = new Pirrest.PhisicsEngine.Vector(0,0);
      if($mass == undefined || $mass < 0)
      {
         this.mass = 0;
      }
      else
      {
         this.mass = $mass;
      }
      var _loc3_ = _root.main_mc.main_cont_mc.level_mc.over_mc.getNextHighestDepth();
      this.dmc = _root.main_mc.main_cont_mc.level_mc.over_mc.createEmptyMovieClip("p_" + _loc3_,_loc3_);
   }
   function verlet($sysObj)
   {
      this.temp.x = this.curr.x;
      this.temp.y = this.curr.y;
      this.curr.x += $sysObj.coeffDamp * (this.curr.x - this.prev.x) + $sysObj.gravity.x;
      this.curr.y += $sysObj.coeffDamp * (this.curr.y - this.prev.y) + $sysObj.gravity.y + this.mass;
      this.prev.x = this.temp.x;
      this.prev.y = this.temp.y;
   }
   function checkCollision($surface, $sysObj)
   {
      $surface.resolveParticleCollision(this,$sysObj);
   }
   function paint()
   {
      this.dmc.clear();
      this.dmc.lineStyle(0,16777215,100);
      Pirrest.PhisicsEngine.Graphics.prototype.paintCircle(this.dmc,this.curr.x,this.curr.y,2);
   }
   function setPos($px, $py)
   {
      this.curr.x = $px;
      this.curr.y = $py;
      this.prev.x = $px;
      this.prev.y = $py;
   }
}
