class Pirrest.PhisicsEngine.Vector
{
   var x;
   var y;
   function Vector($x, $y)
   {
      this.init($x,$y);
   }
   function init($x, $y)
   {
      this.x = $x;
      this.y = $y;
   }
   function dot($v)
   {
      return this.x * $v.x + this.y * $v.y;
   }
   function cross($v)
   {
      return this.x * $v.y - this.y * $v.x;
   }
   function plus($v)
   {
      this.x += $v.x;
      this.y += $v.y;
      return this;
   }
   function plusNew($v)
   {
      return new Pirrest.PhisicsEngine.Vector(this.x + $v.x,this.y + $v.y);
   }
   function minus($v)
   {
      this.x -= $v.x;
      this.y -= $v.y;
      return this;
   }
   function minusNew($v)
   {
      return new Pirrest.PhisicsEngine.Vector(this.x - $v.x,this.y - $v.y);
   }
   function mult($s)
   {
      this.x *= $s;
      this.y *= $s;
      return this;
   }
   function multNew($s)
   {
      return new Pirrest.PhisicsEngine.Vector(this.x * $s,this.y * $s);
   }
   function distance($p)
   {
      var _loc3_ = this.x - $p.x;
      var _loc2_ = this.y - $p.y;
      return Math.sqrt(_loc3_ * _loc3_ + _loc2_ * _loc2_);
   }
   function normalize()
   {
      var _loc2_ = Math.sqrt(this.x * this.x + this.y * this.y);
      this.x /= _loc2_;
      this.y /= _loc2_;
      return this;
   }
}
